-- kagawa

module PolyVarPrelude where
import Testbed
import StaticPrelude

xtyvar = Tyvar "x" Star
xtype  = TVar xtyvar

xstyvar = Tyvar "xs" Star
xstype  = TVar xstyvar

addPVClasses :: EnvTransformer
addPVClasses =   addVariant "List" [xstyvar, xtyvar] []
             <:> addVariant "List2" [xstyvar, xtyvar] [IsIn "List" [xstype, xtype]]
             <:> addVariant "AppendList" [xstyvar, xtyvar] [IsIn "List" [xstype, xtype]]
             <:> addVariant "Expr" [xstyvar] []
             <:> addVariant "ExprF" [xstyvar] [IsIn "Expr" [xstype]]
             <:> addClass "ListAcceptor" [xstyvar, xtyvar] []
             <:> addClass "ExprAcceptor" [xstyvar] []
             <:> addClass "Eq" [xstyvar] []
             <:> addClass "EqList" [xstyvar, xtyvar] []
             <:> instances instsPolyVar

instsPolyVar = [
                ([] :=> (IsIn "List" [xstype, xtype],
                         xstyvar,
                         IsIn "ListAcceptor" [xstype, xtype])),
                ([] :=> (IsIn "List2" [xstype, xtype],
                         xstyvar,
                         IsIn "ListAcceptor" [xstype, xtype])),
                ([] :=> (IsIn "AppendList" [xstype, xtype],
                         xstyvar,
                         IsIn "ListAcceptor" [xstype, xtype])),
                ([] :=> (IsIn "Expr" [xstype],
                         xstyvar,
                         IsIn "ExprAcceptor" [xstype])),  
                ([] :=> (IsIn "ExprF" [xstype],
                         xstyvar,
                         IsIn "ExprAcceptor" [xstype]))  
               ]


defnsHaskellPrelude = [
 "Nil" :>: (Forall [Star, Star] ([IsIn "List" [TGen 0, TGen 1]] :=> (TGen 0))),
 "Cons"  :>: (Forall [Star, Star]
                     ([IsIn "List" [TGen 0, TGen 1]] :=> 
                      (TGen 1 `fn` TGen 0 `fn` TGen 0))), 
 "Cons2"  :>: (Forall [Star, Star]
                     ([IsIn "List2" [TGen 0, TGen 1]] :=> 
                      (TGen 1 `fn` TGen 1 `fn` TGen 0 `fn` TGen 0))),
 "Append"  :>: (Forall [Star, Star]
                     ([IsIn "AppendList" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` TGen 0 `fn` TGen 0))),
 "toListView" :>: (Forall [Star, Star] 
                     ([IsIn "ListAcceptor" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` (foldl TAp tEither [foldl TAp tTuple2 (map TGen [1, 0]),
                                                       tUnit])))),
 "isNull" :>: (Forall [Star, Star] 
                     ([IsIn "ListAcceptor" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` tBool))),
 "hd" :>: (Forall [Star, Star] 
                     ([IsIn "ListAcceptor" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` TGen 1))),
 "tl" :>: (Forall [Star, Star] 
                     ([IsIn "ListAcceptor" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` TGen 0))),

 "Var" :>: (Forall [Star] ([IsIn "Expr" [TGen 0]] :=> (tString `fn` TGen 0))),

 "App" :>: (Forall [Star] ([IsIn "Expr" [TGen 0]] :=> (TGen 0 `fn` TGen 0 `fn` TGen 0))),

 "Lambda" :>: (Forall [Star] ([IsIn "Expr" [TGen 0]] :=> (tString `fn` TGen 0 `fn` TGen 0))),


 "toExprView" :>: (Forall [Star] 
                     ([IsIn "ExprAcceptor" [TGen 0]] :=> 
                      (TGen 0 `fn` (foldl TAp tEither3 [tString,
						        foldl TAp tTuple2 [TGen 0, TGen 0],
                                                        foldl TAp tTuple2 [tString, TGen 0]])))),

 "FullApp" :>: (Forall [Star, Star] ([IsIn "ExprF" [TGen 0], IsIn "ListAcceptor" [TGen 1, TGen 0]]
				     :=> (TGen 0 `fn` TGen 1 `fn` TGen 0))),

 "eq" :>: (Forall [Star] 
                     ([IsIn "Eq" [TGen 0]] :=> 
                      (TGen 0 `fn` TGen 0 `fn` tBool))),
 "ne" :>: (Forall [Star] 
                     ([IsIn "Eq" [TGen 0]] :=> 
                      (TGen 0 `fn` TGen 0 `fn` tBool))),

 "eqCons" :>: (Forall [Star, Star] 
                     ([IsIn "EqList" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` foldl TAp tTuple2 [TGen 1, TGen 0] `fn` tBool))),

 "eqNil" :>: (Forall [Star, Star] 
                     ([IsIn "EqList" [TGen 0, TGen 1]] :=> 
                      (TGen 0 `fn` tBool))),

----------------------------------------------------------------------

  "." :>:
     Forall [Star, Star, Star]
 ([] :=>
    ((TGen 0 `fn` TGen 1) `fn` (TGen 2 `fn` TGen 0) `fn` TGen 2 `fn` TGen 1))
 ]




