-----------------------------------------------------------------------------
-- PolyVarTest:		
-----------------------------------------------------------------------------

module PolyVarTest where
import Testbed
import StaticTest
import PolyVarPrelude

-- for debug 
-- import Hugs.Observe

-----------------------------------------------------------------------------
-- Test Framework:

main       :: IO ()
main        = test static imports testDefns

saveTest   :: IO ()
saveTest    = save "Test" static imports testDefns

static = case ({- preludeClasses <:> testClasses <:> -}addPVClasses) initialEnv of
            Just s -> s
            Nothing -> error "static!!!" 

imports    :: [Assump]
imports     = defnsHaskellPrelude


-----------------------------------------------------------------------------
-- Test Programs:

testDefns :: [BindGroup]
testDefns  = map toBg [
--                [
--                 ("foo",
--                  Nothing,
--                  [([], evar "toListView")])
-- 	       ],

--                -- bar :: bar (xs, ys) = Append (tl xs) ys
--                [
--                 ("bar",
--                  Nothing,
--                  [([PCon tup2Cfun [PVar "xs", PVar "ys"]],
-- 		   ap [evar "Append", ap [evar "tl", evar "xs"], evar "ys"])])
-- 	       ],

               [
           	-- length = xs :: ListAcceptor x => xs -> Int
	   	-- length = lengthView . toListView
	        ("length",
                 Nothing,
                 [([], ap [evar ".", evar "lengthView", evar "toListView"])]),
        	-- lengthView :: xs :: ListAcceptor x => Either (x, xs) () -> Int
        	-- lengthView (Left (x, xs)) = 1 + length xs
        	-- lengthView (Right ()) = 0 
                ("lengthView",
                 Nothing,
                 [ 
                  ([PCon leftCfun [PCon tup2Cfun [PVar "x", PVar "xs"]]],
                   ap [econst plusMfun, elit (LitInt 1),
                                 ap [evar "length", evar "xs"]]),
                  ([PCon rightCfun [PCon unitCfun []]],
                   elit (LitInt 0))])
               ],
            
--  	       [
-- 		-- toListViewCons2 :: xs :: List x2 => (x1, x2, xs) -> Either (x2, xs) z 
--  	        -- toListViewCons2 (x1, x2, xs) = ConsView (x1, Cons(x2, xs))
--                 ("toListViewCons2",
--  		 Nothing,
--  		 [([PCon tup3Cfun [PVar "x1", PVar "x2", PVar "xs"]],
--  		   ap [econst leftCfun,
--  		       ap [econst tup2Cfun, 
--  				evar "x1", ap [evar "Cons", evar "x2", evar "xs"]]])])
--  	       ],

--   	       [
--  	        -- toListViewAppend  :: xs :: AppendList x, xs :: ListAcceptor x => (xs, xs) -> Either (x, xs) ()
--              -- toListViewAppend  (xs, ys) = if isNull xs then toListView ys
--              --                              else Left (hd xs, Append (tl xs) ys)    
--                 ("toListViewAppend ",
--   		 Nothing,
--   		 [([PCon tup2Cfun [PVar "xs", PVar "ys"]],
--   		   If (ap [evar "isNull", evar "xs"])
--   		      (ap [evar "toListView", evar "ys"])
--   		      (ap [econst leftCfun,
--   			   ap [econst tup2Cfun,
--                             ap [evar "hd", evar "xs"],
--   			       ap [evar "Append", ap [evar "tl", evar "xs"], evar "ys"]]])
--   		  )])
--   	       ],

               [
                -- ws = Cons 1 Nil 
                ("ws", Nothing, [([], ap [evar "Cons",  elit (LitInt 1), evar "Nil"])])
                -- ("", Nothing, [([], )])
		],

               [
                -- xs = Cons2 1 2 Nil 
                ("xs", Nothing, [([], ap [evar "Cons2",  elit (LitInt 1), elit (LitInt 2), evar "Nil"])])
                -- ("", Nothing, [([], )])
		],

               [
                -- ys = Append xs xs 
                ("ys", Nothing, [([], ap [evar "Append", evar "xs", evar "xs"])])
                -- ("", Nothing, [([], )])
		],
               [
                -- baz :: Int
                -- baz = length ys
                ("baz", Nothing, [([], ap [evar "length", evar "ys"])])
	       ],
               [
		-- eqConsList :: Either (x, xs) () -> (x, xs) -> Bool
                -- eqConsList (Left (x, xs)) (y, ys) = x==y && xs==ys
                -- eqConsList (Right ())     (_, _)  = False 
                ("eqConsList", Nothing,
		 [([PCon leftCfun [PCon tup2Cfun [PVar "x", PVar "xs"]], PCon tup2Cfun [PVar "y", PVar "ys"]],
		   If (ap [evar "eq", evar "x", evar "y"])
		      (ap [evar "eq", evar "xs", evar "ys"])
		      (elit (LitBool False))
		  ),
		  ([PCon rightCfun [PCon unitCfun []], PCon tup2Cfun [PVar "y", PVar "ys"]],
		    elit (LitBool False))])],


               [
		-- eqNilList :: (Eq x, Eq xs) => Either (x, xs) () -> (x, xs) -> Bool
                -- eqNilList (Left (x, xs)) (y, ys) = x==y && xs==ys
                -- eqNilList (Right ())     (_, _)  = False 
                ("eqNilList", Nothing,
		 [([PCon leftCfun [PCon tup2Cfun [PVar "x", PVar "xs"]]],
		   elit (LitBool False)),
		  ([PCon rightCfun [PCon unitCfun []]],
		   elit (LitBool True))])
	       ], 
               [
               -- eqList :: xs :: EqList x => Either (x, xs) () -> xs -> Bool
	       -- eqList (Left (x, xs)) ys = eqCons ys (x, xs)
	       -- eqList Right          ys = eqNil ys
	       ("eqList", Nothing,
		[([PCon leftCfun [PCon tup2Cfun [PVar "x", PVar "xs"]], PVar "ys"],
		   ap [evar "eqCons", evar "ys", ap [econst tup2Cfun, evar "x", evar "xs"]]),
		  ([PCon rightCfun [PCon unitCfun []], PVar "ys"],
		   ap [evar "eqNil", evar "ys"])])
 	       ],

               [
               -- toExprViewFullApp :: 
	       -- toExprViewFullApp (f, a) = if isNull a then toExprView f
	       --                            else toExprView (FullApp (App f (hd a)) (tl a))
	       ("toExprViewFullApp", Nothing,
		[([PCon tup2Cfun [PVar "f", PVar "a"]],
		  If (ap [evar "isNull", evar "a"])
		     (ap [evar "toExprView", evar "f"])
		     -- (ap [evar "toExprView", evar "f"])
		     (ap [evar "toExprView",
			 ap [evar "FullApp",
			     ap [evar "App", evar "f", ap [evar "hd", evar "a"]],
			     ap [evar "tl", evar "a"]
			    ]
			 ])
		 )
		]
		)
  	       ] --,

--             [
--                 -- ("", Nothing, [([], )])
-- 	       ]
               
 	     ]

